from rocolib.api.components.Component import Component
from rocolib.api.Function import Function

c = Component()

c.addSubcomponent("boat", "BoatBase", inherit=True, prefix=None)
c.inheritAllInterfaces("boat")
c.addSubcomponent("dcMount", "DCMotorMount", inherit=True)

c.addConstraint(("dcMount", "mountWidth"), "boat.width")
c.addConstraint(("dcMount", "supportLength"), "boat.depth")

c.addParameter("topDistance", 50, paramType="length") #@ankur make this half the boat.length
c.addParameter("botDistance", 50, paramType="length")

for i in range(2):
    c.addSubcomponent("split%d" %i, "SplitEdge")
    c.addConstraint(("split%d" %i, "toplength"), "boat.length", "(x,)")

c.addConstraint(("split0", "botlength"), ("topDistance", "botDistance"), "(x[0]-5, 10, x[1]-5)")
c.addConstraint(("split1", "botlength"), ("topDistance", "botDistance"), "(x[1]-5, 10, x[0]-5)")

c.addConnection(("boat", "portedge"), ("split0", "topedge0"))
c.addConnection(("boat", "staredge"), ("split1", "topedge0"))

c.addConnection(("dcMount","rightArmInterface"), ("split0", "botedge1"), angle=-180)
c.addConnection(("dcMount","rightArmInterface"), ("split1", "botedge1"), tabWidth=5)

c.toLibrary("BoatWithDCMount")
